<?php
/*
 * 初心者向けCMS処理
 *
 * Copyright (c) 2024 Crytus Corporation All right reserved.
 */
define("PRODUCT_ID", "basic");
define("MAX_PAGE_LINE", 20);
//define("DIGEST_LEN", 50);

// 情報種類
define("INFO_SETUP", 1);		// 設定
define("INFO_NEWS", 2);			// お知らせ
define("INFO_LIST", 3);			// ページ種類
define("INFO_SCHEDULE", 6);			// 予定入力
define("INFO_PROPATY", 4);		// プロパティ
define("INFO_COMMON", 5);		// 共通設定

//define("INFO_ITEM", 1000);		// ページID加算
define("INFO_ITEM", 20000);		// ページID加算
define("IMAGE_PATH", "./user_data/");
define("INTERNAL_ENCODING", "UTF-8");	// 管理画面漢字コード

// --------------------------------
// メニューの作成
$menu_setup = array(
	array("title" => "設定"),
	array("act" => "@common", "title" => "共通設定"),
	array("act" => "@propaty", "title" => "ページ設定"),
	array("act" => "@news", "title" => "お知らせ"),
	array("act" => "@list", "title" => "記事"),
	array("act" => "@schedule", "title" => "予定入力"),
	array("act" => "@setup", "title" => "設定"),
);

$midashi = "ページ";
if ($setup["midashi"]) {
	$midashi = $setup["midashi"];
}
$menu = array(
	array("title" => $midashi),
);
// ページ種類の選択肢
	$login = get_setup();
	$list = array("" => "");
	for ($i = 1; $i <= 10; $i++) {
		if (trim($login["list" . $i])) {
			$ary = explode("|", trim($login["list" . $i]));
			$list[$i] = $ary[0];
		}
	}
// ページ一覧からメニューを作成
$cond["kind"] = INFO_PROPATY;
$ret = Info::findData($cond);

foreach ($list as $group => $name) {
	$list = array();
	foreach ($ret as $val) {
		$info = get_setup(INFO_PROPATY, $val["info_id"]);
		if ($info["group"] == $group) {
			$list[] = array("act" => "@item" . $val["info_id"], "title" => $info["title"]);
		}
	}
	if ($list) {
		if ($name) {
			$menu[] = array("act" => "", "title" => $name, "comment" => "1");
		}
		foreach ($list as $val2) {
			$menu[] = $val2;
		}
	}
}
// ページ名を取得
$info = get_setup(0, $_REQUEST["id"]);		// ページ設定
if (substr($info["name"], 0, 1) == "@") {
	$block_type = $info["name"];	// 特定のもののみ有効にする
}
// ベースページの一覧
// ブロックリスト
$block_list = array("" => "");
foreach ($cms_setup["block"] as $key => $val) {
	if ($block_type) {
		if ($val["type"] != $block_type) continue;
	} else {
		if ($block_type) continue;
	}
	if (defined("TEST")) {
		$block_list[$key] = $val["title"] . " [" . $key . "]";
	} else {
		$block_list[$key] = $val["title"];
	}
}
//
$menu = array_merge($menu, $menu_setup);

// --------------------------------
// 共通前処理

//$html = &htmltemplate::getInstance();

function html_include($file, $data)
{
	global $copyright;

	if ($copyright) {
		$data["copyright"] = $copyright;
	} else {
		$data["copyright"] = "Copyright (c) q19cms.com All right reserved.";
	}
	if (file_exists("_files/" . $file)) {
		htmltemplate::t_include("_files/" . $file, $data);
	} else {
		$body = load_blob($file);
		echo htmltemplate::buffer($body, $data);
	}
	exit;
}

$act = $_REQUEST["act"];
// TEST
if ($act == "phpinfo") {
	if ($_SESSION["LOGIN"]) {
		phpinfo();
	}
	exit;
}
// memo/versionの取得
if ($act == "__dbinfoget__") {
	echo load_blob($_REQUEST["key"]);
	exit;
}
// 写真表示
if ($act == "get_image") {
	$id = htmlspecialchars($_REQUEST["id"]);
	$file = htmlspecialchars($_REQUEST["file"]);
	$size = htmlspecialchars($_REQUEST["size"]);	// sizeで指定した矩形の切り取り
	$tx = htmlspecialchars($_REQUEST["x"]);	// x,yで指定した矩形の切り取り
	$ty = htmlspecialchars($_REQUEST["y"]);	// x,yで指定した矩形の切り取り
	$pv = htmlspecialchars($_REQUEST["pv"]);
	if ($id || $file) {
		if ($tx || $ty) {
			$sx = 0;
			$sy = 0;
			if ($tx) {
				$sx = $tx;
			}
			if ($ty) {
				$sy = $ty;
			}
		} else if ($size) {
			$sx = $size;
			$sy = $size;
		} else {
			$sx = 0;
			$sy = 0;
		}
		get_image($id, $file, $sx, $sy, $pv);
	}
	exit;
}
if ($act == "get_file") {
	$id = htmlspecialchars($_REQUEST["id"]);
	$img = Image::getData($id);
	if ($img) {
		$filename = $img["name"];
		$ua = $_SERVER['HTTP_USER_AGENT'];
		if (strstr($ua, 'MSIE') && !strstr($ua, 'Opera')) {
		    $filename = mb_convert_encoding($filename, "SJIS", "UTF-8");
		}
		if ($img["file"]) {
			$image = $img["file"];
		} else {
			$file = IMAGE_PATH . $img["save_name"];
			$fp = fopen($file, "rb");
			if ($fp) {
				$image = fread($fp, filesize($file));
				fclose($fp);
			}
		}
		header("Content-disposition: attachment; filename=" . $filename);
		header("Content-type: " . $img["filetype"]);
		if (strstr($ua, 'MSIE')) {
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
			header("Pragma: public");
		} else {
			header("Pragma: no-cache");
		}
		echo $image;
	}
	exit;
}

$act_ary = explode("_", $act);

//-----------------------------------
// HTML向け出力（JSON）サポート終了
/*
if ($act_ary[0] == "getrss") {
	$script_encoding = INTERNAL_ENCODING;

	$kind = $_REQUEST["kind"];
	$setup = get_setup();
	//
	$sql = "select * from info where info.kind=" . INFO_NEWS;
	$inst = DBConnection::getConnection($DB_URI);
	$ret = $inst->search_sql($sql);
	$list = array();
	if ($ret["count"]) {
		foreach ($ret["data"] as $val) {
			$item = get_setup(INFO_NEWS, $val["info_id"]);
			if ($item["open"]) {
				$item["reg_date"] = $val["reg_date"];
				if ($kind) {
					if ($kind == $item["kind"]) {
						$list[$item["news_date"]] = $item;
					}
				} else {
					$list[$item["news_date"]] = $item;
				}
			}
		}
	}
	// 並べ替え
	$rss = array();
	if ($list) {
		krsort($list);
		foreach ($list as $val) {
			$rss[] = $val;
		}
	}
	//
	$output["title"] = $title;
	$output["rss"] = $rss;

	$contents = toJson($output);
	$contents = eregi_replace("&", "&amp;", $contents);
	$contents = eregi_replace("[\n\r]", "", $contents);
	echo "getData(" . $contents . ")";
	exit;
}
*/
//-----------------------------------
// RSS出力->サポート終了
/*
if (($act_ary[0] == "atom")||($act_ary[0] == "rss10")||($act_ary[0] == "rss20")) {
	$script_encoding = INTERNAL_ENCODING;

	$kind = $_REQUEST["kind"];
	$setup = get_setup();
	//
	$sql = "select * from info where info.kind=" . INFO_NEWS;
	$inst = DBConnection::getConnection($DB_URI);
	$ret = $inst->search_sql($sql);
	$list = array();
	if ($ret["count"]) {
		foreach ($ret["data"] as $val) {
			$item = get_setup(INFO_NEWS, $val["info_id"]);
			if ($item["open"]) {
				$item["reg_date"] = $val["reg_date"];
				if ($kind) {
					if ($kind == $item["kind"]) {
						$list[$item["news_date"]] = $item;
					}
				} else {
					$list[$item["news_date"]] = $item;
				}
			}
		}
		krsort($list);
	}
	$rss["about"] = htmlspecialchars($setup["site_url"]);
	$rss["title"] = $setup["site_name"];
	$rss["link"] = htmlspecialchars($setup["site_url"]);
	$rss["description"] = $setup["site_desc"];
	$rss["creator"] = $setup["site_owner"];
	$rss["rights"] = $setup["site_owner"];
	$rss["date"] = date('Y-m-d\TH:i:s+09:00', time());
	$rss["url"] = $setup["site_url"];
	//
	foreach ($list as $val) {
		unset($item);
		$item["link"] = htmlspecialchars($val["url"]);
		$item["title"] = htmlspecialchars($val["title"]);
		if (mb_strlen($item["contents"], SCRIPT_ENCODING) > DIGEST_LEN) {
			$item["description"] = htmlspecialchars(mb_substr(strip_tags(nl2br($val["contents"])), 0, DIGEST_LEN, SCRIPT_ENCODING)) . "…";
		} else {
			$item["description"] = htmlspecialchars(strip_tags(nl2br($val["contents"])));
		}
		$item["encoded"] = $val["contents"];

		$item["creator"] = $setup["site_owner"];
//		$tm = mktime(substr($val["reg_date"], 11, 2), substr($val["reg_date"], 14, 2), substr($val["reg_date"], 17, 2), substr($val["reg_date"], 5, 2), substr($val["reg_date"], 8, 2), substr($val["reg_date"], 0, 4));
		$tm = mktime(0, 0, 0, substr($val["news_date"], 5, 2), substr($val["news_date"], 8, 2), substr($val["news_date"], 0, 4));
		$item["date"] = date('Y-m-d\TH:i:s+09:00', $tm);
		$rss["item"][] = $item;
	}
	header('content-type: text/xml; charset=utf-8');
	if ($act_ary[0] == "atom") {
	//	$data = htmltemplate::t_buffer("atom.xml", $rss);
		$file = "atom.xml";
	}
	if ($act_ary[0] == "rss10") {
	//	$data = htmltemplate::t_buffer("rss10.xml", $rss);
		$file = "rss10.xml";
	}
	if ($act_ary[0] == "rss20") {
	//	$data = htmltemplate::t_buffer("rss20.xml", $rss);
		$file = "rss20.xml";
	}
	$body = load_blob($file);
	$data = htmltemplate::buffer($body, $rss);
	//echo mb_convert_encoding($data, 'utf8', SCRIPT_ENCODING);
	echo '<?xml version="1.0" encoding="UTF-8" ?' . '>' . "\r\n" . $data;
	exit;
}
*/
if ($act == "load") {
	$file = $_REQUEST["f"];
	$body = load_blob($file);
	echo $body;
	exit;
}
//-----------------------------------
// 認証
if ($act == "@login") {	// ログイン
	$login = get_setup();
	if (!$login) {
		if ($act_ary[0] != "setup") {
			$act = "@setup_new";
			$act_ary = explode("_", $act);
		}
	} else {
		$act = "@login";
	}
	if ($_REQUEST["adminid"] && $_REQUEST["passwd"]) {
		$adminid = htmlspecialchars($_REQUEST["adminid"]);
		$passwd = htmlspecialchars($_REQUEST["passwd"]);
		if (($login["loginid"] == $adminid)&&($login["passwd"] == $passwd)) {
			$_SESSION["LOGIN"] = $login;
			$memo = trim(load_blob("memo.txt"));
			if (!$memo) {	// 試用版
				if (!$login["limit"]) {
					$login["limit"] = date('Y-m-d', time() + 86400 * 14);
					save_infoitem(INFO_SETUP, $login);
				} else {
					if ((strtotime($login["limit"]) + 86400) < time()) {		// 期限切れ
						$data["message"] = "試用版の利用期限が切れました。";
					}
				}
			} else {
				if ($login["limit"]) {
					unset($login["limit"]);
					save_infoitem(INFO_SETUP, $login);
				}
			}
			if (!$data["message"]) {	// ログイン完了
				exec_file("manage.php");
				header("location: ?act=@setup");
				exit;
			}
		}
		if (!$data["message"]) {
			$data["message"] = "ログインできません。IDとパスワードを確認してください。";
		}
	}
	html_include("login.html", $data);
	exit;
}
if ($act == "logout") {	// ログアウト
	unset($_SESSION["LOGIN"]);
	header("location: ./");
	exit;
}

// --------------------------------
// お知らせ
$news_data = array(
	"id" => INFO_NEWS,
	"name" => "@news",
	"title" => "お知らせ設定",
	"list" => array(
		"form" => "list.html",
		"items" => array(
			"title" => array(
				"title" => "タイトル",
			),
			"news_date" => array(
				"title" => "日付",
			),
/*
			"kind" => array(
				"title" => "種類",
			),
*/
			"open" => array(
				"title" => "公開",
				"value" => array(
					"0" => "",
					"1" => "公開",
					"2" => "非公開",
				),
			),
		),
	),
	"input" => array(
		"form" => "contents.html",
		"items" => array(
			"title" => array(	// タイトル
				"title" => "タイトル",
				"type" => "text",
			),
			"news_date" => array(	// 日付
				"title" => "日付",
				"type" => "date",
			),
			"image" => array(	// 画像
				"title" => "画像",
				"type" => "image",
				"info" => "表示パーツにより使われません",
			),
			"contents" => array(	// 説明文
				"title" => "内容",
				"type" => "textarea",
				"info" => "表示パーツにより使われません",
			),
			"url" => array(	// URL
				"title" => "リンク先",
				"type" => "text",
			),
			"kind" => array(	// 種類
				"title" => "種類",
				"type" => "select",
				"list" => "",
			),
			"open" => array(	// 公開
				"title" => "公開",
				"type" => "select",
				"list" => array(
					"1" => "公開",
					"2" => "非公開",
				),
			),
		),
	),
);

if ($act_ary[0] == "@news") {
	login_check("ログインしてください");
	// 種類の選択肢設定
	$login = get_setup();
	$kiji_list = array("" => "");
	for ($i = 1; $i <= 10; $i++) {
		if (trim($login["news" . $i])) {
			$ary = explode("|", trim($login["news" . $i]));
			$kiji_list[$i] = $ary[0];
		}
	}
	if (count($kiji_list) < 2) {		// 設定なし
		$news_data["input"]["items"]["kind"]["title"] = "";	// 選択無し
	}
	$news_data["input"]["items"]["kind"]["list"] = $kiji_list;
	//
	$script_encoding = INTERNAL_ENCODING;
	cms($news_data, $act_ary[1], $menu);
}

// --------------------------------
// 一覧データ
$list_data = array(
	"id" => INFO_LIST,
	"name" => "@list",
	"title" => "記事一覧設定",
	"list" => array(
		"form" => "list.html",
		"items" => array(
			"title" => array(
				"title" => "タイトル",
			),
			"kind" => array(
				"title" => "種類",
			),
			"news_date" => array(
				"title" => "日付",
			),
			"open" => array(
				"title" => "公開",
				"value" => array(
					"0" => "",
					"1" => "公開",
					"2" => "非公開",
				),
			),
		),
	),
	"input" => array(
		"form" => "contents.html",
		"items" => array(
			"title" => array(	// タイトル
				"title" => "タイトル",
				"type" => "text",
			),
			"news_date" => array(	// 日付
				"title" => "日付",
				"type" => "date",
			),
			"image" => array(	// 画像
				"title" => "画像",
				"type" => "image",
				"info" => "表示パーツにより使われません",
			),
			"contents" => array(	// 説明文
				"title" => "内容",
				"type" => "textarea",
				"info" => "表示パーツにより使われません",
			),
			"url" => array(	// URL
				"title" => "リンク先",
				"type" => "text",
			),
			"kind" => array(	// 種類
				"title" => "種類",
				"type" => "select",
				"list" => "",
			),
			"open" => array(	// 公開
				"title" => "公開",
				"type" => "select",
				"list" => array(
					"1" => "公開",
					"2" => "非公開",
				),
			),
		),
	),
);

if ($act_ary[0] == "@list") {
	login_check("ログインしてください");
	// 種類の選択肢設定
	$login = get_setup();
	$kiji_list = array("" => "");
	for ($i = 1; $i <= 10; $i++) {
		if (trim($login["kiji" . $i])) {
			$ary = explode("|", trim($login["kiji" . $i]));
			$kiji_list[$i] = $ary[0];
		}
	}
	if (count($kiji_list) < 2) {		// 設定なし
		$list_data["input"]["items"]["kind"]["title"] = "";	// 選択無し
	}
	$list_data["input"]["items"]["kind"]["list"] = $kiji_list;
	$list_data["list"]["items"]["kind"]["values"] = $kiji_list;
	//
	$script_encoding = INTERNAL_ENCODING;
	cms($list_data, $act_ary[1], $menu);
}
// --------------------------------
// カレンダーデータ
$schedule_data = array(
	"id" => INFO_SCHEDULE,
	"name" => "@schedule",
	"title" => "カレンダー設定",
	"list" => array(
		"form" => "list.html",
		"items" => array(
			"title" => array(
				"title" => "タイトル",
			),
			"news_date" => array(
				"title" => "日付",
			),
/*
			"kind" => array(
				"title" => "種類",
			),
*/
			"open" => array(
				"title" => "公開",
				"value" => array(
					"0" => "",
					"1" => "公開",
					"2" => "非公開",
				),
			),
		),
	),
	"input" => array(
		"form" => "contents.html",
		"items" => array(
			"title" => array(	// タイトル
				"title" => "タイトル",
				"type" => "text",
			),
			"news_date" => array(	// 日付
				"title" => "日付",
				"type" => "date",
			),
			"image" => array(	// 画像
				"title" => "画像",
				"type" => "image",
				"info" => "表示パーツにより使われません",
			),
			"contents" => array(	// 説明文
				"title" => "内容",
				"type" => "textarea",
				"info" => "表示パーツにより使われません",
			),
			"url" => array(	// URL
				"title" => "リンク先",
				"type" => "text",
			),
			"kind" => array(	// 種類
				"title" => "種類",
				"type" => "select",
				"list" => "",
			),
			"open" => array(	// 公開
				"title" => "公開",
				"type" => "select",
				"list" => array(
					"1" => "公開",
					"2" => "非公開",
				),
			),
		),
	),
);

if ($act_ary[0] == "@schedule") {
	login_check("ログインしてください");
	// 種類の選択肢設定
	$login = get_setup();
	$kiji_list = array("" => "");
	for ($i = 1; $i <= 10; $i++) {
		if (trim($login["list" . $i])) {
			$ary = explode("|", trim($login["schedule" . $i]));
			$kiji_list[$i] = $ary[0];
		}
	}
	if (count($kiji_list) < 2) {		// 設定なし
		$schedule_data["input"]["items"]["kind"]["title"] = "";	// 選択無し
	}
	$schedule_data["input"]["items"]["kind"]["list"] = $kiji_list;
	//
	$script_encoding = INTERNAL_ENCODING;
	cms($schedule_data, $act_ary[1], $menu);
}
// --------------------------------
// ページ名のチェック
function func_name_check($id, $val)
{
	if ($val) {
		if (!preg_match('/^[ -~]+$/', $val)) {
			return "半角英数字で入力してください";
		}
		$cond = array(
			"kind" => INFO_PROPATY,
		);
		$list = Info::findData($cond);
		foreach ($list as $key => $val2) {
			$info = get_setup(INFO_PROPATY, $val2["info_id"]);
			if ($info["name"] == $val) {
				if ($id != $val2["info_id"]) {
					return "この名前は使えません";
				}
			}
		}
	}
	return "";
}

$propaty_data = array(
	"id" => INFO_PROPATY,
	"name" => "@propaty",
	"title" => "設定項目",
	"list" => array(
		"form" => "list.html",
		"items" => array(
/*
			"kind" => array(
				"title" => "ページ種類",
				"values" => $setup_page,
			),
*/
			"title" => array(
				"title" => "名称",
			),
			"name" => array(
				"title" => "ページ名",
			),
			"group" => array(
				"title" => "グループ",
				"values" => array(
					"" => "",
				),
			),
		),
	),
	"input" => array(
		"form" => "contents.html",
		"items" => array(
			"title" => array(
				"title" => "タイトル",
				"type" => "text",
				"require" => "1",
			),
			"group" => array(
				"title" => "グループ",
				"type" => "select",
				"list" => array(
					"" => "",
				),
			),
			"name" => array(
				"title" => "ページ名",
				"type" => "text",
				"info" => "半角英数字で指定してください。",
				"check" => "func_name_check",
				"require" => "1",
			),
			"dummy1" => array(
				"title" => "ブロック1",
				"type" => "comment",
				"down" => "do_exchange('info1', 'info2')",
			),
			"info1_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info1_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy2" => array(
				"title" => "ブロック2",
				"type" => "comment",
				"up" => "do_exchange('info1', 'info2')",
				"down" => "do_exchange('info2', 'info3')",
			),
			"info2_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info2_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy3" => array(
				"title" => "ブロック3",
				"type" => "comment",
				"up" => "do_exchange('info2', 'info3')",
				"down" => "do_exchange('info3', 'info4')",
			),
			"info3_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info3_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy4" => array(
				"title" => "ブロック4",
				"type" => "comment",
				"up" => "do_exchange('info3', 'info4')",
				"down" => "do_exchange('info4', 'info5')",
			),
			"info4_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info4_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy5" => array(
				"title" => "ブロック5",
				"type" => "comment",
				"up" => "do_exchange('info4', 'info5')",
				"down" => "do_exchange('info5', 'info6')",
			),
			"info5_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info5_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy6" => array(
				"title" => "ブロック6",
				"type" => "comment",
				"up" => "do_exchange('info5', 'info6')",
				"down" => "do_exchange('info6', 'info7')",
			),
			"info6_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info6_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy7" => array(
				"title" => "ブロック7",
				"type" => "comment",
				"up" => "do_exchange('info6', 'info7')",
				"down" => "do_exchange('info7', 'info8')",
			),
			"info7_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info7_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy8" => array(
				"title" => "ブロック8",
				"type" => "comment",
				"up" => "do_exchange('info7', 'info8')",
				"down" => "do_exchange('info8', 'info9')",
			),
			"info8_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info8_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy9" => array(
				"title" => "ブロック9",
				"type" => "comment",
				"up" => "do_exchange('info8', 'info9')",
				"down" => "do_exchange('info9', 'info10')",
			),
			"info9_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info9_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
			"dummy10" => array(
				"title" => "ブロック10",
				"type" => "comment",
				"up" => "do_exchange('info9', 'info10')",
			),
			"info10_title" => array(
				"title" => "タイトル",
				"type" => "text",
			),
			"info10_type" => array(
				"title" => "ブロック形式",
				"type" => "select",
				"list" => $block_list,
			),
		),
	),
);

if ($act_ary[0] == "@propaty") {
	login_check("ログインしてください");
	// ページ種類の選択肢設定
	$login = get_setup();
	$list = array("" => "");
	for ($i = 1; $i <= 10; $i++) {
		if (trim($login["list" . $i])) {
			$ary = explode("|", trim($login["list" . $i]));
			$list[$i] = $ary[0];
		}
	}
	if (count($list) < 2) {		// 設定なし
		$propaty_data["input"]["items"]["group"]["title"] = "";	// 選択無し
	}
	$propaty_data["input"]["items"]["group"]["list"] = $list;
	$propaty_data["list"]["items"]["group"]["values"] = $list;
	//
	$script_encoding = INTERNAL_ENCODING;
	cms($propaty_data, $act_ary[1], $menu);
}

// --------------------------------
// ITEM
$item_data = array(
	"id" => INFO_ITEM,
	"name" => "@item",
	"title" => "ページ",
	"preview" => "?act=@preview&id=",
	"input" => array(
		"form" => "contents.html",
		"items" => array(
			"title" => array(	// タイトル
				"title" => "名称",
				"type" => "text",
				"require" => "1",
				"info" => "ページのタイトルになります。",
			),
			"contents" => array(	// 説明文
				"title" => "説明",
				"type" => "textarea",
				"info" => "記入するとページの説明(description)になります。",
			),
		),
	),
);

if (substr($act_ary[0], 0, 5) == "@item") {
	login_check("ログインしてください");
	$script_encoding = INTERNAL_ENCODING;
	//
	if ($_REQUEST["id"]) {
		$id = $_REQUEST["id"];
		$info = Info::getData($id);
		$kind = $info["kind"];
	} else {
		$item_id = substr($act_ary[0], 5);
		$kind = INFO_ITEM + $item_id;
		$cond["kind"] = $kind;
		$ret = Info::findData($cond);
		if (!$ret) {
			// 新規
			$rec["kind"] = $kind;
			$id = Info::addData($rec);
			$item["title"] = "";
			save_infoitem($id, $item);
		} else {
			// 編集
			$id = $ret[0]["info_id"];
		}
	}
	//
	$info = get_setup(INFO_PROPATY, $kind - INFO_ITEM);		// ページ設定
	for ($i = 1; $i < 11; $i++) {
		$key = "info" . $i;
		if ($info[$key . "_title"] && $info[$key . "_type"]) {
			if ($cms_setup["block"][$info[$key . "_type"]]["input"]) {
				$item = $cms_setup["block"][$info[$key . "_type"]]["input"];
				if ($cms_setup["block"][$info[$key . "_type"]]["func_kanri"]) {
					$item = call_user_func($cms_setup["block"][$info[$key . "_type"]]["func_kanri"], $item);
				}
				foreach ($item as $key2 => $val) {
					$item_data["input"]["items"]["dummy" . $i] = array("title" => $info[$key . "_title"],"type" => "comment", "class" => "openclose");
					$item_data["input"]["items"][$key . "_" . $key2] = $val;
				}
			}
		}
	}
	//
	$_REQUEST["id"] = $id;
	if ($act_ary[1] == "") {
		$act_ary[1] = "edit";
	}
	//
	cms($item_data, $act_ary[1], $menu);
}

// --------------------------------
// 共通設定
$common_data = array(
	"id" => INFO_COMMON,
	"name" => "@common",
	"title" => "共通設定",
	"input" => array(
		"form" => "contents.html",
		// 設定により追加される
	),
);

if ($act_ary[0] == "@common") {
	login_check("ログインしてください");
	//
	$script_encoding = INTERNAL_ENCODING;
	//
	$common_data["input"] = array_merge($common_data["input"], $cms_setup["common_items"]);	// 設定ファイルから
	//
	if ($act_ary[1] == "update") {
		cms($common_data, $act_ary[1], $menu);
	}
	unset($cond);
	$cond["kind"] = INFO_COMMON;
	$ret = Info::findData($cond);
	if (!$ret) {
		cms($common_data, "new", $menu);
	} else {
		$_REQUEST["id"] = $ret[0]["info_id"];
		if ($act_ary[1] == "") {
			$act_ary[1] = "edit";
		}
		cms($common_data, $act_ary[1], $menu);
	}
}
// --------------------------------
// 設定
function func_setup($id, $item)
{
	//
//	if ($item["limit"]) {
//		$item["limit"] = date("Y-m-d", $item["limit"]);
//	}
	return $item;
}

function func_license_check($id, $item)
{
	if ($item == "") return "";		// 未記入
	//
	if (!preg_match('/\<\!--License[0-9a-zA-Z]+--\>/', $item)) {
		return "ライセンスコードを確認してください";
	}
	return "";
}
$setup_data = array(
	"id" => INFO_SETUP,
	"name" => "@setup",
	"title" => "設定",
	"input" => array(
		"form" => "contents.html",
		"func" => "func_setup",
		"items" => array(
			"loginid" => array(	// ID
				"title" => "ログインID",
				"type" => "text",
			),
			"passwd" => array(
				"title" => "パスワード",
				"type" => "text",
			),
			"dummy1" => array(
				"title" => "CMS情報",
				"type" => "comment",
			),
			"version" => array(
				"title" => "Version",
				"type" => "display",
				"value" => "",
			),
			"serial" => array(
				"title" => "シリアル番号",
				"type" => "display",
				"value" => "",
			),
			"limit" => array(
				"title" => "試用期限",
				"type" => "display",
				"value" => "",
			),
			"license" => array(
				"title" => "テンプレートライセンスコード",
				"type" => "text",
				"info" => "テンプレートパーティより取得したライセンスコードを記入",
				"check" => "func_license_check",
			),
			"dummy5" => array(
				"title" => "お知らせ種類",
				"type" => "comment",
				"class" => "openclose",
			),
			"notice1" => array(
				"title" => "変更すると既存のお知らせの表示も変わります",
				"type" => "comment",
				"class"=> "notice",
			),
			"news1" => array(	
				"title" => "種類1",
				"type" => "text",
			),
			"news2" => array(	
				"title" => "種類2",
				"type" => "text",
			),
			"news3" => array(	
				"title" => "種類3",
				"type" => "text",
			),
			"news4" => array(	
				"title" => "種類4",
				"type" => "text",
			),
			"news5" => array(	
				"title" => "種類5",
				"type" => "text",
			),
			"dummy6" => array(
				"title" => "ページ種類",
				"type" => "comment",
				"class" => "openclose",
			),
			"notice2" => array(
				"title" => "変更すると既存のページ一覧の表示も変わります",
				"type" => "comment",
				"class"=> "notice",
			),
			"list1" => array(	
				"title" => "種類1",
				"type" => "text",
			),
			"list2" => array(	
				"title" => "種類2",
				"type" => "text",
			),
			"list3" => array(	
				"title" => "種類3",
				"type" => "text",
			),
			"list4" => array(	
				"title" => "種類4",
				"type" => "text",
			),
			"list5" => array(	
				"title" => "種類5",
				"type" => "text",
			),
			"dummy7" => array(
				"title" => "予定種類",
				"type" => "comment",
				"class" => "openclose",
			),
			"notice3" => array(
				"title" => "変更すると既存の予定の表示も変わります",
				"type" => "comment",
				"class"=> "notice",
			),
			"schedule1" => array(	
				"title" => "種類1",
				"type" => "text",
			),
			"schedule2" => array(	
				"title" => "種類2",
				"type" => "text",
			),
			"schedule3" => array(	
				"title" => "種類3",
				"type" => "text",
			),
			"schedule4" => array(	
				"title" => "種類4",
				"type" => "text",
			),
			"schedule5" => array(	
				"title" => "種類5",
				"type" => "text",
			),
			"dummy8" => array(
				"title" => "記事種類",
				"type" => "comment",
				"class" => "openclose",
			),
			"notice4" => array(
				"title" => "変更すると既存の記事の表示も変わります",
				"type" => "comment",
				"class"=> "notice",
			),
			"kiji1" => array(	
				"title" => "種類1",
				"type" => "text",
			),
			"kiji2" => array(	
				"title" => "種類2",
				"type" => "text",
			),
			"kiji3" => array(	
				"title" => "種類3",
				"type" => "text",
			),
			"kiji4" => array(	
				"title" => "種類4",
				"type" => "text",
			),
			"kiji5" => array(	
				"title" => "種類5",
				"type" => "text",
			),
		),
	),
);

if ($act_ary[0] == "@setup") {
	login_check("ログインしてください");
	$script_encoding = INTERNAL_ENCODING;
	//
	if ($act_ary[1] == "update") {
		cms($setup_data, $act_ary[1], $menu);
	}
	$setup_data["input"]["items"]["version"]["value"] = str_replace("\n", " ", load_blob("version.txt"));
	$setup_data["input"]["items"]["serial"]["value"] = trim(load_blob("memo.txt"));
	if (!($setup_data["input"]["items"]["serial"]["value"])) {
		$setup_data["input"]["items"]["serial"]["value"] = "試用版";
	} else {
		$setup_data["input"]["items"]["limit"]["title"] = "";
	}
	unset($cond);
	$cond["kind"] = INFO_SETUP;
	$ret = Info::findData($cond);
	if (!$ret) {
		$setup_data["message"] = "ログインIDとパスワードを入力してください。(入力後ログインが必要です）";
		cms($setup_data, "new", $menu);
	} else {
		$_REQUEST["id"] = $ret[0]["info_id"];
		if ($act_ary[1] == "") {
			$act_ary[1] = "edit";
		}
		cms($setup_data, $act_ary[1], $menu);
	}
}
// --------------------------------
// トップ
//header("location: ?act=item_list");
//exit;
//--------------------------------------------
// ログインしていなければ、ログインフォームを表示し、ログイン後もとの処理へ
function login_check($msg)
{
	// ログイン確認
	if (!isset($_SESSION["LOGIN"])) {
		// ログイン後の飛び先（戻る場所）
		$_SESSION['NEXT_URL'] = $act;
		// 現在のパラメータを保存
		$_SESSION['REQUEST'] = $_REQUEST;
		$_SESSION['LOGIN_MESSAGE'] = $msg;
		// ログイン処理へ
		header("Location: ?act=login");
		exit;
	}
}
// ---------------------------------
// 設定値取得（単一情報）
function get_setup($kind=INFO_SETUP, $info_id=0)
{
	$setup = array();
	if ($kind) {
		$cond["kind"] = $kind;
	}
	if ($info_id) {
		$cond["info_id"] = $info_id;
	}
	$ret = Info::findData($cond);
	if ($ret) {
		$setup = get_infoitem($ret[0]["info_id"]);
	}
	return $setup;
}
// ---------------------------------
function get_propaty($id)
{
	global $DB_URI;

	$sql = "select * from info where kind=" . INFO_PROPATY . " and info_id in (select info_id from info_item where kind='kind' and value=" . $id . ")";
	$inst = DBConnection::getConnection($DB_URI);
	$ret = $inst->search_sql($sql);
	$info = array();
	$special = array();
	$image = array();
	if ($ret["count"]) {
		$list = get_infoitem($ret["data"][0]["info_id"]);
		if ($list) {
			foreach ($list as $key => $val) {
				if (substr($key, 0, 4) == "info") {
					$info[substr($key, 4)] = $val;
				}
				if ((substr($key, 0, 7) == "special")&& $val) {
					$special[substr($key, 7)] = $val;
				}
				if (substr($key, 0, 5) == "image") {
					if ($val) {
						$image[substr($key, 5)] = $val;
					}
				}
			}
			ksort($info);
			ksort($special);
		}
	}
	if (!$image) {
		$image = array("1" => "画像1", "2" => "画像2", "3" => "画像3", "4" => "画像4", "5" => "画像5", "6" => "画像6", "7" => "画像7", "8" => "画像8", "9" => "画像9", "10" => "画像10");
	}
	return array($info, $special, $image);
}
// ---------------------------------
// 配列をJSON形式に変換
function toJson($data, $eo="UTF-8")
{
	if (is_array($data)) {
		$i = 0;
		$str = "{";
		foreach ($data as $key => $val) {
			if ($i) $str .= ",";
			$str .= "'" . $key . "':" . toJson($val, $eo);
			$i++;
		}
		$str .= "}";
	} else {
//		$str = "'" . str_replace("'", "\\'", strip_tags(html_entity_decode(mb_convert_encoding($data, $eo, "auto")))) . "'";
		$str = "'" . str_replace("'", "\\'", html_entity_decode(mb_convert_encoding($data, $eo, "auto"))) . "'";
	}
	return $str;
}
// ---------------------------------
function page_index2($cur, $pages)
{
	$page = array();
	$no = 0;
	if ($cur > 0) {
		$page['prev'] = array('no' => $cur - 1, 'name' => '前へ', 'link' => 1);
	}
	for ($i = 0; $i < $pages; $i++) {
		if ($i == $cur) {
			$page['list'][$no] = array('no' => $i, 'name' => $i + 1);
		} else {
			$page['list'][$no] = array('no' => $i, 'name' => $i + 1, 'link' => 1);
		}
		$no++;
	}
	if ($cur < ($pages - 1)) {
		$page['next'] = array('no' => $cur + 1, 'name' => '次へ', 'link' => 1);
	}
	return $page;
}
// デバッグダンプ
function dump($info)
{
	echo "<pre>";
	var_dump($info);
	echo "</pre>";
}
