<?php
//require_once("dbaccess.inc");
class Image extends DbAccess {

	static $t_table = array(
		'title' => 'image',
		'name' => 'image',
		'fields' => array(
			1 => 'image_id',
			2 => 'name',
			3 => 'title',
			4 => 'image',
			5 => 'filetype',
			6 => 'size',
			7 => 'save_name',
			8 => 'reg_date',
		),
		'seq' => 'image_id'
	);

	function __construct($page=0, $limit=0, $order="", $search=array()) {
		parent::DbAccess($page, $limit, $order, $search, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function getData($id, $fields="", $raw=null) {
		return parent::_getData($id, $fields, $raw, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function addData($data, $raw=null) {
		if (!isset($data["reg_date"])) {
			$data["reg_date"] = "now()";
		}
		return parent::_addData($data, $raw, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function updateData($id, $data, $raw=null) {
		return parent::_updateData($id, $data, $raw, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function deleteData($id) {
		return parent::_deleteData($id, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function findData($cond, $fields=null, $raw=null, $order=null, $page=null) {
		return parent::_findData($cond, $fields, $raw, self::$t_table["name"], $order, $page);
	}
}
// 画像の保存
function save_image($img, $title="")
{
	$fp = fopen($img["tmp_name"], "rb");
	if ($fp) {
		$image = fread($fp, filesize($img["tmp_name"]));
		fclose($fp);
		$flag = false;
		$im_inp = ImageCreateFromString($image);
		if (function_exists("exif_read_data") && (($img["type"] == "image/pjpeg")||($img["type"] == "image/jpeg"))) {
			// 向きの変更が必要なら対応
			$exif = exif_read_data($img["tmp_name"]);
			if ($exif) {
				if ($exif["Orientation"]) {
					$ort = $exif["Orientation"];
				} else {
					$ort = $exif['IFD0']['Orientation'];
				}
				switch ($ort) {
				case 3: // 180 rotate left
					$im_inp = imagerotate($im_inp, 180, 0);
					$flag = true;
					break;
				case 6: // 90 rotate right
					$im_inp = imagerotate($im_inp, -90, 0);
					$flag = true;
					break;
				case 8:    // 90 rotate left
					$im_inp = imagerotate($im_inp, 90, 0);
					$flag = true;
					break;
				}
			}
			if ($flag) {
				// $imageを更新
				ob_start();
				if (($img["type"] == "image/pjpeg")||($img["type"] == "image/jpeg")) {
					imagejpeg($im_inp);
				} else if ($img["type"] == "image/gif") {
					imagegif($im_inp);
				} else if ($img["type"] == "image/bmp") {
					imagebmp($im_inp);
				} else if (($img["type"] == "image/png")||($img["type"] == "image/x-png")) {
					imagepng($im_inp);
				} else {
					imagejpeg($im_inp);
				}
				$image = ob_get_contents();
				ob_end_clean();
			}
		}
		if ($title == "") {
			$ary = explode(".", $img["name"]);
			if ($ary > 1) {
				$title = $ary[count($ary) - 2];
			} else {
				$title = $img["name"];
			}
		}
		if (($img["type"] == "image/pjpeg")||($img["type"] == "image/jpeg")||($img["type"] == "image/gif")||
			($img["type"] == "image/bmp")||($img["type"] == "image/png")||($img["type"] == "image/x-png")) {
			$item["x"] = @imagesx($im_inp);
			$item["y"] = @imagesy($im_inp);
			@ImageDestroy($im_inp);
		}
		$item["name"] = $img["name"];
		$item["filetype"] = $img["type"];
		$item["size"] = $img["size"];
		$item["title"] = $title;
		if (!defined("IMAGE_PATH")) {
			// 画像をDBへ保存
			$item["image"] = $image;
		}
		$id = Image::addData($item, true);
		//if ($id && $title) {
		//	$upd["title"] = $title;
		//	Image::updateData($id, $upd);	// 漢字コード変換対応
		//}
		if (defined("IMAGE_PATH")) {
			// 画像をファイルへ保存
			$ext = "";
			if (($img["type"] == "image/pjpeg")||($img["type"] == "image/jpeg")) {
				$ext = "jpg";
			} else if ($img["type"] == "image/gif") {
				$ext = "gif";
			} else if ($img["type"] == "image/bmp") {
				$ext = "bmp";
			} else if ($img["type"] == "image/png") {
				$ext = "png";
			}
			if ($ext == "") {
				$ext = "dat";
				$ary = explode(".", $item["name"]);
				if (count($ary) > 1) {
					$ext = $ary[count($ary) - 1];
				}
			}
			//$save_name = sprintf("%08d.%s", $id, $ext);		// 保存ファイル名
			$save_name = sprintf("%08d_%s.%s", $id, substr(md5(time().$img["tmp_name"]), 0, 6), $ext);
			if ($flag) {
				// 回転した画像を保存
				$fp = fopen(IMAGE_PATH . $save_name, "wb");	// 処理した物を保存
				fwrite($fp, $image);
				fclose($fp);
			} else {
				// アップロードしたファイルをそのまま保存
				copy($img["tmp_name"], IMAGE_PATH . $save_name);
			}
			//
			unset($upd);
			$upd["save_name"] = $save_name;
			Image::updateData($id, $upd);
		}
		return $id;
	}
	return false;
}
// 指定のイメージが自分のものなら削除
function delete_image($id)
{
	$img = Image::getData($id);
	if (defined("IMAGE_PATH") && $img["save_name"]) {
		if (file_exists(IMAGE_PATH . $img["save_name"])) {
			unlink(IMAGE_PATH . $img["save_name"]);
		}
	}
	return Image::deleteData($id);
	//return true;
}
// 画像の取得
function get_image($id, $file="", $sx=0, $sy=0, $pv=0, $mx=0, $my=0)
{
	if ($id) {	// DBから
		// キャッシュのチェック
		if (defined("IMAGE_CACHE")) {
			$img_file = sprintf(IMAGE_CACHE . "%08d_%03d_%03d.jpg", $id, $sx, $sy);
			if (file_exists($img_file)) {
				$fp = fopen($img_file, "rb");
				$img = fread($fp, filesize($img_file));
				fclose($fp);
				header("Content-type: image/jpeg");
				echo $img;
				return;
			}
		}
		$img = Image::getData($id, null, true);
		if ($img) {
			if (defined("IMAGE_PATH")) {
				$file = IMAGE_PATH . $img["save_name"];
			} else {
				// 読み込んだデータを内部画像へ
				$im_inp = ImageCreateFromString($img["image"]);
				if ($pv) {	// 参照回数カウント
					$sql = "update image set page_view=page_view+1 where image_id=" . $id;
					$inst = DBConnection::getConnection($DB_URI);
					$inst->db_exec($sql);
				}
			}
		}
	}
	unset($im_imp);
	if ($file) {		// ファイルから
		$file_type = getimagesize($file);
		if ($file_type["mime"] == "image/gif") {
			$im_inp = ImageCreateFromGIF($file);
		}
		if ($file_type["mime"] == "image/jpg") {
			$im_inp = ImageCreateFromJPEG($file);
		}
		if ($file_type["mime"] == "image/jpeg") {
			$im_inp = ImageCreateFromJPEG($file);
		}
		if ($file_type["mime"] == "image/png") {
			$im_inp = ImageCreateFromPNG($file);
		}
	}
	if ($im_inp) {
		$px = @imagesx($im_inp);
		$py = @imagesy($im_inp);
		if ($mx || $my) {	// 最大サイズ指定
			if ($mx) {
				if ($px > $mx) {
					$sx = $mx;
				} else {
					$sx = $px;
				}
			}
			if ($my) {
				if ($py > $my) {
					$sy = $my;
				} else {
					$sy = $py;
				}
			}
		}
		if ($sx || $sy) {	// サイズ指定有り
			if (!$sx) {		// 横指定なし
				$sx = intval($px / $py * $sy);
			} else if (!$sy) {	// 縦指定なし
				$sy = intval($py / $px * $sx);
			}
			//
			$rb = floatval($px) / floatval($py);
			$ra = floatval($sx) / floatval($sy);
			if ($ra == $rb) {
				$x = 0;	// 切り取り始点
				$y = 0;
				$wx = $px;	// 切り取りサイズ
				$wy = $py;
			} else if ($ra > $rb) {
				$wy = intval($px / $ra);
				$wx = $px;
				$x = 0;	// 切り取り始点
				$y = intval(($py - $wy) / 2);
			} else {
				$wx = intval($py * $ra);
				$wy = $py;
				$x = intval(($px - $wx) / 2);	// 切り取り始点
				$y = 0;
			}
			// サイズ変更後の画像データを生成
			$im_out = ImageCreateTrueColor($sx, $sy);
			// 切り抜き
			ob_start();
			if (ImageCopyResized($im_out, $im_inp, 0, 0, $x, $y, $sx, $sy, $wx, $wy)) {
				imagejpeg($im_out);
			} else {
				imagejpeg($im_inp);
			}
			$img = ob_get_contents();
			ob_end_clean();
			//
			if ($img_file && defined("IMAGE_CACHE")) {
				// キャッシュファイル作成
				$fp = fopen($img_file, "wb");
				fwrite($fp, $img);
				fclose($fp);
			}
			//
			header("Content-type: image/jpeg");
			echo $img;	// 画像出力
			//
			ImageDestroy($im_out);
			ImageDestroy($im_inp);
		} else {	// オリジナルのサイズのまま
			ob_start();
			imagejpeg($im_inp);
			$img = ob_get_contents();
			ob_end_clean();
			ImageDestroy($im_inp);
			if ($img_file && defined("IMAGE_CACHE")) {
				// キャッシュファイル作成
				$fp = fopen($img_file, "wb");
				fwrite($fp, $img);
				fclose($fp);
			}
			//
			header("Content-type: image/jpeg");
			echo $img;	// 画像出力
		}
	} else {
		// エラー
		header("HTTP/1.1 404 Not Found");	// ファイルが見つからない
		exit;
	}
}
